# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: psc_release_workflow/PSC Release workflow
# Date: 2005/02/03 00:59:12.124 GMT
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.3 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupPSC_release_workflow(wf):
    "..."
    wf.setProperties(title='PSC Release workflow')

    for s in ['in-progress', 'planning', 'published']:
        wf.states.addState(s)
    for t in ['release', 'retract', 'begin', 're-plan']:
        wf.transitions.addTransition(t)
    for v in ['action', 'review_history', 'actor', 'comments', 'time']:
        wf.variables.addVariable(v)
    for l in ['reviewer_queue']:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'Add portal content', 'Add PloneSoftwareCenter Content'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('planning')

    ## States initialization
    sdef = wf.states['planning']
    sdef.setProperties(title="""The release is in the planning stages""",
                       transitions=('begin', 'release'))
    sdef.setPermission('Access contents information', 1, [])
    sdef.setPermission('View', 1, [])
    sdef.setPermission('Modify portal content', 1, [])
    sdef.setPermission('Add portal content', 0, ['Manager', 'Owner'])
    sdef.setPermission('Add PloneSoftwareCenter Content', 0, ['Manager', 'Owner'])
    
    sdef = wf.states['in-progress']
    sdef.setProperties(title="""Work on the release is in progress""",
                       transitions=('re-plan', 'release'))
    sdef.setPermission('Access contents information', 1, [])
    sdef.setPermission('View', 1, [])
    sdef.setPermission('Modify portal content', 1, [])
    sdef.setPermission('Add portal content', 0, ['Manager', 'Owner'])
    sdef.setPermission('Add PloneSoftwareCenter Content', 0, ['Manager', 'Owner'])

    sdef = wf.states['published']
    sdef.setProperties(title="""The release has been completed""",
                       transitions=('re-plan', 'retract'))
    sdef.setPermission('Access contents information', 1, [])
    sdef.setPermission('View', 1, [])
    sdef.setPermission('Modify portal content', 1, [])
    sdef.setPermission('Add portal content', 0, ['Manager', 'Owner'])
    sdef.setPermission('Add PloneSoftwareCenter Content', 0, ['Manager', 'Owner'])


    ## Transitions initialization
    tdef = wf.transitions['release']
    tdef.setProperties(title="""Mark as released""",
                       new_state_id="""published""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make release""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content'},
                       )

    tdef = wf.transitions['retract']
    tdef.setProperties(title="""Retract release""",
                       new_state_id="""in-progress""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Retract release""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content'},
                       )

    tdef = wf.transitions['begin']
    tdef.setProperties(title="""Begin work on a release""",
                       new_state_id="""in-progress""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Begin work""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content'},
                       )

    tdef = wf.transitions['re-plan']
    tdef.setProperties(title="""Return to planning state""",
                       new_state_id="""planning""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Re-plan""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    ## Worklists Initialization
    ldef = wf.worklists['reviewer_queue']
    ldef.setProperties(description="""Reviewer tasks""",
                       actbox_name="""Pending (%(count)d)""",
                       actbox_url="""%(portal_url)s/search?review_state=pending""",
                       actbox_category="""global""",
                       props={'guard_permissions': 'Review portal content', 'var_match_review_state': 'pending'})


def createPSC_release_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupPSC_release_workflow(ob)
    return ob

def install ():
    addWorkflowFactory(createPSC_release_workflow,
                       id='psc_release_workflow',
                       title='PSC Release workflow')

    
